"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.amplicodePipeline = void 0;
const amplicode_1 = require("../stages/options/pieces/amplicode");
const defaultGetOptions_1 = require("../stages/options/defaultGetOptions");
const defaultConfigureGenerator_1 = require("../stages/configuring/defaultConfigureGenerator");
const amplicodeGetAnswers_1 = require("../stages/answers/amplicodeGetAnswers");
const amplicodeDeriveTemplateModel_1 = require("../stages/template-model/amplicodeDeriveTemplateModel");
const amplicodeWrite_1 = require("../stages/writing/amplicodeWrite");
const amplicodeGetGraphQLSchema_1 = require("../stages/graphql-schema/amplicodeGetGraphQLSchema");
function amplicodePipeline(input, gen) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const { templateDir, questions = [], optionsConfig = amplicode_1.amplicodeCommonOptionsConfig } = input;
        const { getOptions = defaultGetOptions_1.defaultGetOptions, configureGenerator = defaultConfigureGenerator_1.defaultConfigureGenerator, getAnswers = amplicodeGetAnswers_1.amplicodeGetAnswers, getGraphQLSchema = amplicodeGetGraphQLSchema_1.amplicodeGetGraphQLSchema, deriveTemplateModel = amplicodeDeriveTemplateModel_1.amplicodeDeriveTemplateModel, write = amplicodeWrite_1.amplicodeWrite } = (_a = input.stages) !== null && _a !== void 0 ? _a : {};
        // Setting the generator's destinationRoot (which happens inside configureGenerator) will change the current working directory,
        // therefore we need to save the directory from which the generator command was invoked.
        const invocationDir = process.cwd();
        // Obtain the options passed from command line
        const options = yield getOptions(optionsConfig, gen);
        // Apply default configuration to the Yeoman generator
        yield configureGenerator(templateDir, gen, options);
        // Obtain GraphQL schema
        const { schema, schemaPath } = yield getGraphQLSchema(options, invocationDir);
        // Obtain answers
        const answers = yield getAnswers(options, gen, questions);
        // // Derive template model from options, answers and GraphQL schema
        const templateModel = yield deriveTemplateModel(options, answers, schema, schemaPath);
        // Write files to disk, performing interpolations using the template model
        yield write(templateModel, gen);
    });
}
exports.amplicodePipeline = amplicodePipeline;
//# sourceMappingURL=amplicodePipeline.js.map