"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.amplicodeGetGraphQLSchema = void 0;
const graphql_1 = require("graphql");
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
const load_1 = require("@graphql-tools/load");
/**
 * This is the path:
 *
 * project-folder
 * ├── generation
 * │   └── node_modules
 * │       └── @haulmont
 * │           └── jmix-front-generator
 * │               └── bin <-------------- FROM HERE
 * └── schema.graphql <------------------- TO HERE
 *
 */
const DEFAULT_SCHEMA_PATH = '../../../../../schema.graphql';
const amplicodeGetGraphQLSchema = (options, invocationDir) => __awaiter(void 0, void 0, void 0, function* () {
    if (options.schema == null) {
        return { schema: undefined, schemaPath: undefined };
    }
    const schemaPathAbsolute = getSchemaPath(invocationDir, options.schema);
    const { dest = invocationDir } = options;
    const codegenYmlPath = path.resolve(dest);
    const schemaPathRelativeToCodegenYml = path.relative(codegenYmlPath, schemaPathAbsolute);
    if (!fs.existsSync(schemaPathAbsolute)) {
        throw new Error(`GraphQL schema not found at "${schemaPathAbsolute}"`);
    }
    const schemaString = fs.readFileSync(schemaPathAbsolute, 'utf-8');
    let isSdlFormat = false;
    let introspection;
    try {
        introspection = JSON.parse(schemaString);
    }
    catch (e) {
        isSdlFormat = true;
    }
    const schema = isSdlFormat
        ? yield load_1.loadSchema(schemaString, { loaders: [] })
        : graphql_1.buildClientSchema(introspection.data);
    return { schema, schemaPath: schemaPathRelativeToCodegenYml };
});
exports.amplicodeGetGraphQLSchema = amplicodeGetGraphQLSchema;
function getSchemaPath(invocationDir, schemaArg) {
    if (schemaArg == null) {
        return DEFAULT_SCHEMA_PATH;
    }
    if (path.isAbsolute(schemaArg)) {
        return schemaArg;
    }
    return path.join(invocationDir, schemaArg);
}
//# sourceMappingURL=amplicodeGetGraphQLSchema.js.map