"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dollarsToUnderscores = void 0;
/**
 * Replaces all occurrences of a dollar sign ($) inside a string with underscores (_).
 *
 * Useful when generating GraphQL templates for an entity that has a dollar sign in its name
 * (e.g. scr$Car), since corresponding GraphQL types will have underscore in its place
 * (e.g. inp_scr_CarOrderBy).
 *
 * @param input
 */
const dollarsToUnderscores = (input) => {
    return input.replace(/\$/g, '_');
};
exports.dollarsToUnderscores = dollarsToUnderscores;
//# sourceMappingURL=dollars-to-underscores.js.map