import { Entity, EntityAttribute, ProjectModel } from "./cuba-model";
import { EntityInfo, RestQueryInfo, RestServiceMethodInfo, RestServiceMethodModel, ViewInfo } from "../studio/studio-model";
export declare function findEntity(projectModel: ProjectModel, entityInfo: EntityInfo | string): Entity | undefined;
export declare function findEntityByFqn(projectModel: ProjectModel, fqn: string): Entity | undefined;
export declare function getAllEntities(projectModel: ProjectModel): Entity[];
export declare function findView(projectModel: ProjectModel, view: ViewInfo): import("./cuba-model").View | undefined;
export declare function findViewsForEntity(projectModel: ProjectModel, entityName: string): ViewInfo[];
export declare function findQuery(projectModel: ProjectModel, queryInfo: RestQueryInfo): import("./cuba-model").RestQuery | undefined;
export declare function findServiceMethod(projectModel: ProjectModel, methodInfo: RestServiceMethodInfo): RestServiceMethodModel | null;
export declare function collectAttributesFromHierarchy(entity: Entity, projectModel: ProjectModel): EntityAttribute[];
export declare function isBaseProjectEntity(entity: Entity, projectModel: ProjectModel): boolean;
export declare function composeParentFqn(parentPackage: string | undefined, parentClassName: string | undefined): string;
