"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const utils_1 = require("./utils");
describe('normalizeRelativePath()', () => {
    it('Replaces the backslashes in the provided path with forward slashes', () => {
        chai_1.expect(utils_1.normalizeRelativePath('..\\..\\')).to.equal('../../');
        chai_1.expect(utils_1.normalizeRelativePath('..\\..')).to.equal('../../');
    });
    it('Adds a trailing slash if it is missing', () => {
        chai_1.expect(utils_1.normalizeRelativePath('../..')).to.equal('../../');
    });
    it('Does not add an additional trailing slash if already present', () => {
        chai_1.expect(utils_1.normalizeRelativePath('../../')).to.equal('../../');
    });
});
//# sourceMappingURL=utils.test.js.map