"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.options = exports.generator = exports.ReactTSAddonGenerator = void 0;
const path_1 = __importDefault(require("path"));
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const options_1 = require("./options");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return options_1.addonOptions; } });
const template_model_1 = require("./template-model");
const write_1 = require("./write");
const YeomanGenerator_1 = require("../../../building-blocks/YeomanGenerator");
class ReactTSAddonGenerator extends YeomanGenerator_1.YeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    generate() {
        return __awaiter(this, void 0, void 0, function* () {
            yield amplicodePipeline_1.amplicodePipeline({
                templateDir: path_1.default.join(__dirname, 'template'),
                stages: {
                    deriveTemplateModel: template_model_1.deriveTemplateModel,
                    write: write_1.write
                }
            }, this);
        });
    }
}
exports.ReactTSAddonGenerator = ReactTSAddonGenerator;
exports.generator = ReactTSAddonGenerator;
//# sourceMappingURL=index.js.map