import { Entity, EntityAttribute, ProjectModel, ViewProperty } from "../../../common/model/cuba-model";
import { EntityTemplateModel } from "./template-model";
export declare enum ScreenType {
    BROWSER = "browser",
    EDITOR = "editor"
}
export declare function createEntityTemplateModel(entity: Entity, projectModel: ProjectModel): {
    path: string;
    name?: string | undefined;
    className: string;
    packageName: string;
    dataStore?: string | undefined;
    table?: string | undefined;
    parentClassName: string;
    discriminator?: string | undefined;
    updatable: boolean;
    creatable: boolean;
    hasUuid: boolean;
    softDelete: boolean;
    versioned: boolean;
    reference?: string | undefined;
    parentPackage: string;
    embeddable: boolean;
    persistentEntity: boolean;
    replaceParent: boolean;
    systemLevel: boolean;
    namePattern?: string | undefined;
    mappedSuperclass: boolean;
    fqn: string;
    imported: boolean;
    attributes: EntityAttribute[];
    inheritanceType?: import("../../../common/model/cuba-model").InheritanceType | undefined;
    idAttributeName?: string | undefined;
};
/**
 *
 * @param projectModel
 * @param entity
 * @returns `true` if a given entity is a descendant of `BaseStringIdEntity`
 */
export declare function isStringIdEntity(projectModel: ProjectModel, entity: Entity): boolean;
export declare function getDisplayedAttributes(viewProperties: ViewProperty[], entity: EntityTemplateModel, projectModel: ProjectModel, screenType: ScreenType): EntityAttribute[];
