"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.commonEntityManagementQuestions = void 0;
exports.commonEntityManagementQuestions = [
    {
        caption: 'List component name',
        code: 'listComponentName',
        propertyType: "POLYMER_COMPONENT_NAME" /* POLYMER_COMPONENT_NAME */,
        defaultValue: 'List',
        required: true,
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: 'Entity list mode',
        // description: 'Possible values: ' +
        //   '"edit" (there will be buttons to create and edit entity), ' +
        //   '"view" (read-only, there will be no action buttons), ' +
        //   '"view with details" (read-only, there will be a button to view entity details). ' +
        //   'Presence of delete button depends on whether delete mutation has been provided.',
        code: 'mode',
        propertyType: "OPTION" /* OPTION */,
        defaultValue: 'edit',
        options: ['edit', 'view', 'view with details'],
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: 'Query to load items',
        code: 'listQuery',
        propertyType: "GRAPHQL_QUERY" /* GRAPHQL_QUERY */,
        required: true,
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: 'Mutation to delete an item',
        code: 'deleteMutation',
        propertyType: "GRAPHQL_MUTATION" /* GRAPHQL_MUTATION */,
        required: false,
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: 'Name of the id attribute',
        code: 'listIdField',
        propertyType: "STRING" /* STRING */,
        required: false,
        defaultValue: 'id',
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: "Add to menu",
        code: "shouldAddToMenu",
        propertyType: "BOOLEAN" /* BOOLEAN */,
        defaultValue: true,
        required: true,
        step: {
            name: "Entity List",
            order: "1"
        }
    },
    {
        caption: 'Details component name',
        code: 'detailsComponentName',
        propertyType: "POLYMER_COMPONENT_NAME" /* POLYMER_COMPONENT_NAME */,
        defaultValue: 'Details',
        required: true,
        step: {
            name: "Entity Details",
            order: "2"
        }
    },
    {
        caption: 'Query to load item',
        code: 'detailsQuery',
        propertyType: "GRAPHQL_QUERY" /* GRAPHQL_QUERY */,
        required: true,
        step: {
            name: "Entity Details",
            order: "2"
        }
    },
    {
        caption: 'Mutation to create or update item',
        code: 'upsertMutation',
        propertyType: "GRAPHQL_MUTATION" /* GRAPHQL_MUTATION */,
        required: false,
        step: {
            name: "Entity Details",
            order: "2"
        }
    },
    {
        caption: 'Name of the id attribute',
        code: 'detailsIdField',
        propertyType: "STRING" /* STRING */,
        defaultValue: 'id',
        required: false,
        step: {
            name: "Entity Details",
            order: "2"
        }
    }
];
//# sourceMappingURL=answers.js.map